org.apache.poi.ss.formula.ptg

## Class Ref3DPxg

- java.lang.Object
- - org.apache.poi.ss.formula.ptg.Ptg
  - - org.apache.poi.ss.formula.ptg.OperandPtg
    - - org.apache.poi.ss.formula.ptg.RefPtgBase
      - - org.apache.poi.ss.formula.ptg.Ref3DPxg

- All Implemented Interfaces:
    Duplicatable, Pxg, Pxg3D

      public final class Ref3DPxg
      extends RefPtgBase
      implements Pxg3D

  XSSF 3D Reference

  Defines a cell in an external or different sheet.

  This is XSSF only, as it stores the sheet / book references in String form. The HSSF equivalent using indexes is `Ref3DPtg`

- - ### Field Summary

    - ### Fields inherited from class org.apache.poi.ss.formula.ptg.Ptg

      `CLASS_ARRAY, CLASS_REF, CLASS_VALUE, EMPTY_PTG_ARRAY`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `Ref3DPxg(int externalWorkbookNumber, SheetIdentifier sheetName, CellReference c)`
    `Ref3DPxg(int externalWorkbookNumber, SheetIdentifier sheetName, java.lang.String cellref)`
    `Ref3DPxg(Ref3DPxg other)`
    `Ref3DPxg(SheetIdentifier sheetName, CellReference c)`
    `Ref3DPxg(SheetIdentifier sheetName, java.lang.String cellref)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `Ref3DPxg` | `copy()`
    `java.lang.String` | `format2DRefAsString()`
    `int` | `getExternalWorkbookNumber()`
    `java.lang.String` | `getLastSheetName()`
    `java.lang.String` | `getSheetName()`
    `int` | `getSize()`
    `void` | `setLastSheetName(java.lang.String sheetName)`
    `void` | `setSheetName(java.lang.String sheetName)`
    `java.lang.String` | `toFormulaString()` return a string representation of this token alone
    `java.lang.String` | `toString()` Overridden toString method to ensure object hash is not printed.
    `void` | `write(LittleEndianOutput out)`

    - ### Methods inherited from class org.apache.poi.ss.formula.ptg.RefPtgBase

      `formatReferenceAsString, getColumn, getDefaultOperandClass, getRow, isColRelative, isRowRelative, readCoordinates, setColRelative, setColumn, setRow, setRowRelative, writeCoordinates`

    - ### Methods inherited from class org.apache.poi.ss.formula.ptg.OperandPtg

      `isBaseToken`

    - ### Methods inherited from class org.apache.poi.ss.formula.ptg.Ptg

      `createPtg, doesFormulaReferToDeletedCell, getEncodedSize, getEncodedSizeWithoutArrayData, getPtgClass, getRVAType, readTokens, serializePtgs, setClass`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### Ref3DPxg

          public Ref3DPxg(Ref3DPxg other)

    - #### Ref3DPxg

          public Ref3DPxg(int externalWorkbookNumber,
                          SheetIdentifier sheetName,
                          java.lang.String cellref)

    - #### Ref3DPxg

          public Ref3DPxg(int externalWorkbookNumber,
                          SheetIdentifier sheetName,
                          CellReference c)

    - #### Ref3DPxg

          public Ref3DPxg(SheetIdentifier sheetName,
                          java.lang.String cellref)

    - #### Ref3DPxg

          public Ref3DPxg(SheetIdentifier sheetName,
                          CellReference c)

  - ### Method Detail

    - #### toString

          public java.lang.String toString()

      Description copied from class: `Ptg`
      Overridden toString method to ensure object hash is not printed. This helps get rid of gratuitous diffs when comparing two dumps Subclasses may output more relevant information by overriding this method
      Overrides:
        `toString` in class `Ptg`

    - #### getExternalWorkbookNumber

          public int getExternalWorkbookNumber()

      Specified by:
        `getExternalWorkbookNumber` in interface `Pxg`

    - #### getSheetName

          public java.lang.String getSheetName()

      Specified by:
        `getSheetName` in interface `Pxg`

    - #### getLastSheetName

          public java.lang.String getLastSheetName()

      Specified by:
        `getLastSheetName` in interface `Pxg3D`

    - #### setSheetName

          public void setSheetName(java.lang.String sheetName)

      Specified by:
        `setSheetName` in interface `Pxg`

    - #### setLastSheetName

          public void setLastSheetName(java.lang.String sheetName)

      Specified by:
        `setLastSheetName` in interface `Pxg3D`

    - #### format2DRefAsString

          public java.lang.String format2DRefAsString()

    - #### toFormulaString

          public java.lang.String toFormulaString()

      Description copied from class: `Ptg`
      return a string representation of this token alone
      Specified by:
        `toFormulaString` in interface `Pxg`
      Specified by:
        `toFormulaString` in class `Ptg`

    - #### getSize

          public int getSize()

      Specified by:
        `getSize` in class `Ptg`
      Returns:
        the encoded length of this Ptg, including the initial Ptg type identifier byte.

    - #### write

          public void write(LittleEndianOutput out)

      Specified by:
        `write` in class `Ptg`

    - #### copy

          public Ref3DPxg copy()

      Specified by:
        `copy` in interface `Duplicatable`
      Specified by:
        `copy` in class `OperandPtg`
      Returns:
        a deep copy of the implementing class / instance

Copyright 2020 The Apache Software Foundation or its licensors, as applicable.